<?php
/**
 * Copyright (C) 2017-2019 Petr Hucik <petr@getdatakick.com>
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@getdatakick.com so we can send you a copy immediately.
 *
 * @author    Petr Hucik <petr@getdatakick.com>
 * @copyright 2017-2019 Petr Hucik
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 */

namespace Chex;

use Chex;

class AppTranslation
{
    /**
     * @var Chex
     */
    private $module;

    /**
     * @param Chex $module
     */
    public function __construct($module)
    {
        $this->module = $module;
    }

    /**
     * @return array
     */
    public function getFrontTranslations()
    {
        return $this->changed(array(
            "%s (optional)" => $this->l('%s (optional)'),
            "%s *" => $this->l('%s *'),
            "%s is required" => $this->l('%s is required'),
            "-- Nothing selected --" => $this->l('-- Nothing selected --'),
            "Add coupon" => $this->l('Add coupon'),
            "Addresses in %s" => $this->l('Addresses in %s'),
            "Billing address" => $this->l('Billing address'),
            "Cart" => $this->l('Cart'),
            "Choose shipping and payment method" => $this->l('Choose shipping and payment method'),
            "Choose shipping method" => $this->l('Choose shipping method'),
            "Choosing one of the following addresses can impact shipping price or payment options" => $this->l('Choosing one of the following addresses can impact shipping price or payment options'),
            "Complete order" => $this->l('Complete order'),
            "Confirm order" => $this->l('Confirm order'),
            "Confirmation" => $this->l('Confirmation'),
            "Country" => $this->l('Country'),
            "Create new address or" => $this->l('Create new address or'),
            "Creating account..." => $this->l('Creating account...'),
            "Creating free order" => $this->l('Creating free order'),
            "Discounts" => $this->l('Discounts'),
            "Dismiss" => $this->l('Dismiss'),
            "Do you have any discount coupon?" => $this->l('Do you have any discount coupon?'),
            "Done" => $this->l('Done'),
            "Edit" => $this->l('Edit'),
            "Email address" => $this->l('Email address'),
            "Enter billing address" => $this->l('Enter billing address'),
            "Enter coupon code" => $this->l('Enter coupon code'),
            "Enter personal details" => $this->l('Enter personal details'),
            "Enter your email address" => $this->l('Enter your email address'),
            "Enter your password" => $this->l('Enter your password'),
            "Failed to reset password" => $this->l('Failed to reset password'),
            "Failed to update cart: %s" => $this->l('Failed to update cart: %s'),
            "Final price has changed after we created your account. Please verify the new price and confirm checkout again" => $this->l('Final price has changed after we created your account. Please verify the new price and confirm checkout again'),
            "Forgot your password?" => $this->l('Forgot your password?'),
            "Free shipping" => $this->l('Free shipping'),
            "Gift" => $this->l('Gift'),
            "Invalid VAT number" => $this->l('Invalid VAT number'),
            "Invalid coupon code" => $this->l('Invalid coupon code'),
            "Invalid postal code" => $this->l('Invalid postal code'),
            "Invalid user email or password" => $this->l('Invalid user email or password'),
            "Invalid value" => $this->l('Invalid value'),
            "Minimal purchase total is %s without tax. Please amend your cart." => $this->l('Minimal purchase total is %s without tax. Please amend your cart.'),
            "No address in %s was found. Choosing one of the following addresses can impact shipping price or payment options" => $this->l('No address in %s was found. Choosing one of the following addresses can impact shipping price or payment options'),
            "No carrier available" => $this->l('No carrier available'),
            "No carrier selected" => $this->l('No carrier selected'),
            "No payment methods available" => $this->l('No payment methods available'),
            "No products in the cart" => $this->l('No products in the cart'),
            "Other addresses" => $this->l('Other addresses'),
            "Password reset confirmation email has already been sent" => $this->l('Password reset confirmation email has already been sent'),
            "Password reset confirmation email has been sent to your email address" => $this->l('Password reset confirmation email has been sent to your email address'),
            "Pay %s" => $this->l('Pay %s'),
            "Payment options" => $this->l('Payment options'),
            "Personal details" => $this->l('Personal details'),
            "Please make sure your enter valid [1]Tax number[/1] in address section" => $this->l('Please make sure your enter valid [1]Tax number[/1] in address section'),
            "Please select existing address or" => $this->l('Please select existing address or'),
            "Please wait" => $this->l('Please wait'),
            "Postal code for %s must follow this format: %s" => $this->l('Postal code for %s must follow this format: %s'),
            "Prices are tax excluded" => $this->l('Prices are tax excluded'),
            "Prices are tax included" => $this->l('Prices are tax included'),
            "Quantity" => $this->l('Quantity'),
            "Quantity: " => $this->l('Quantity: '),
            "Redirecting to payment page..." => $this->l('Redirecting to payment page...'),
            "Saving billing address..." => $this->l('Saving billing address...'),
            "Saving shipping address..." => $this->l('Saving shipping address...'),
            "Select basic informations" => $this->l('Select basic informations'),
            "Select billing address" => $this->l('Select billing address'),
            "Select carrier" => $this->l('Select carrier'),
            "Select country" => $this->l('Select country'),
            "Select payment method" => $this->l('Select payment method'),
            "Select shipping address" => $this->l('Select shipping address'),
            "Select shipping options for %s" => $this->l('Select shipping options for %s'),
            "Select shipping" => $this->l('Select shipping'),
            "Select state" => $this->l('Select state'),
            "Shipping address" => $this->l('Shipping address'),
            "Shipping and billing address" => $this->l('Shipping and billing address'),
            "Shipping options for %s" => $this->l('Shipping options for %s'),
            "Shipping options" => $this->l('Shipping options'),
            "Shipping to [1]%s[/1] via [2]%s[/2]" => $this->l('Shipping to [1]%s[/1] via [2]%s[/2]'),
            "Shipping to [1]%s[/1] via [2]%s[/2]. You will pay using [3]%s[/3]" => $this->l('Shipping to [1]%s[/1] via [2]%s[/2]. You will pay using [3]%s[/3]'),
            "Shipping to" => $this->l('Shipping to'),
            "Shipping" => $this->l('Shipping'),
            "Sign in" => $this->l('Sign in'),
            "State" => $this->l('State'),
            "Tax" => $this->l('Tax'),
            "This checkbox must be checked" => $this->l('This checkbox must be checked'),
            "This is not a valid address" => $this->l('This is not a valid address'),
            "This is not a valid city name" => $this->l('This is not a valid city name'),
            "This is not a valid email address" => $this->l('This is not a valid email address'),
            "This is not a valid identification number" => $this->l('This is not a valid identification number'),
            "This is not a valid name" => $this->l('This is not a valid name'),
            "This is not a valid password" => $this->l('This is not a valid password'),
            "This is not a valid phone number" => $this->l('This is not a valid phone number'),
            "This transaction can be [1]exempt of VAT[/1] according to section 259B of the General Tax Code." => $this->l('This transaction can be [1]exempt of VAT[/1] according to section 259B of the General Tax Code.'),
            "This transaction will be [1]exempt of VAT[/1] according to section 259B of the General Tax Code." => $this->l('This transaction will be [1]exempt of VAT[/1] according to section 259B of the General Tax Code.'),
            "Total (tax excl.)" => $this->l('Total (tax excl.)'),
            "Total products" => $this->l('Total products'),
            "Total" => $this->l('Total'),
            "Unknown error" => $this->l('Unknown error'),
            "Use different address for invoice" => $this->l('Use different address for invoice'),
            "VAT exemption" => $this->l('VAT exemption'),
            "Verifying data..." => $this->l('Verifying data...'),
            "We are verifying your email address, please wait..." => $this->l('We are verifying your email address, please wait...'),
            "We don't offer shipping to this location" => $this->l('We don\'t offer shipping to this location'),
            "We need your email address to send your receipt." => $this->l('We need your email address to send your receipt.'),
            "Welcome back" => $this->l('Welcome back'),
            "Welcome back, please sign in to your account" => $this->l('Welcome back, please sign in to your account'),
            "Welcome back, please sign in to your account, or continue with" => $this->l('Welcome back, please sign in to your account, or continue with'),
            "Wrapping" => $this->l('Wrapping'),
            "You will pay using [1]%s[/1]" => $this->l('You will pay using [1]%s[/1]'),
            "Your country" => $this->l('Your country'),
            "Your shopping cart is empty" => $this->l('Your shopping cart is empty'),
            "create a new one" => $this->l('create a new one'),
            "guest checkout" => $this->l('guest checkout'),
            "select existing one" => $this->l('select existing one')
        ));
    }

    /**
     * @return array
     */
    public function getBackTranslations()
    {
        return $this->changed(array(
            "%s fields" => $this->l('%s fields'),
            "%s module" => $this->l('%s module'),
            "Add address" => $this->l('Add address'),
            "Add my IP address" => $this->l('Add my IP address'),
            "Address fields" => $this->l('Address fields'),
            "Agree to terms and conditions" => $this->l('Agree to terms and conditions'),
            "Allow floating cart" => $this->l('Allow floating cart'),
            "Buy license" => $this->l('Buy license'),
            "Cancel" => $this->l('Cancel'),
            "Cart settings" => $this->l('Cart settings'),
            "Cart summary position" => $this->l('Cart summary position'),
            "Changes in new version:" => $this->l('Changes in new version:'),
            "Check for updates" => $this->l('Check for updates'),
            "Checkbox" => $this->l('Checkbox'),
            "Checking for new version of this module" => $this->l('Checking for new version of this module'),
            "Checkout blocks" => $this->l('Checkout blocks'),
            "Close" => $this->l('Close'),
            "Confirmation fields" => $this->l('Confirmation fields'),
            "Contact permission" => $this->l('Contact permission'),
            "Contact" => $this->l('Contact'),
            "Countries selector" => $this->l('Countries selector'),
            "Country selector" => $this->l('Country selector'),
            "Create new field" => $this->l('Create new field'),
            "Custom field has been deleted" => $this->l('Custom field has been deleted'),
            "Delete field?" => $this->l('Delete field?'),
            "Delete" => $this->l('Delete'),
            "Display all countries" => $this->l('Display all countries'),
            "Display only active countries" => $this->l('Display only active countries'),
            "Display options" => $this->l('Display options'),
            "Do you really want to delete this custom field?" => $this->l('Do you really want to delete this custom field?'),
            "Domain name" => $this->l('Domain name'),
            "Download latest version" => $this->l('Download latest version'),
            "Edit field" => $this->l('Edit field'),
            "Email address" => $this->l('Email address'),
            "Email" => $this->l('Email'),
            "Enable sandbox mode" => $this->l('Enable sandbox mode'),
            "Enter checkbox label" => $this->l('Enter checkbox label'),
            "Enter field label" => $this->l('Enter field label'),
            "Enter placeholder text" => $this->l('Enter placeholder text'),
            "Every license key is valid for one domain only. Please provide domain name for your [1]front office[/1]" => $this->l('Every license key is valid for one domain only. Please provide domain name for your [1]front office[/1]'),
            "Failed to delete field: %s" => $this->l('Failed to delete field: %s'),
            "Failed to save field: %s" => $this->l('Failed to save field: %s'),
            "Failed to update preferences: %s" => $this->l('Failed to update preferences: %s'),
            "Field has been saved" => $this->l('Field has been saved'),
            "Field type" => $this->l('Field type'),
            "Fields" => $this->l('Fields'),
            "Generate license" => $this->l('Generate license'),
            "I agree" => $this->l('I agree'),
            "I also offer [1]%s support[/1] a [2]custom development[/2] services. If you are looking for an experienced %s developer then look no further. Send me an email, I would be happy to help." => $this->l('I also offer [1]%s support[/1] a [2]custom development[/2] services. If you are looking for an experienced %s developer then look no further. Send me an email, I would be happy to help.'),
            "IP address #%s" => $this->l('IP address #%s'),
            "If you find any bug or have feature request then please post it on [1]forum[/1] dedicated to this module. Or simply send me an [2]email[/2]" => $this->l('If you find any bug or have feature request then please post it on [1]forum[/1] dedicated to this module. Or simply send me an [2]email[/2]'),
            "In order to use this module you need valid [1]license key[/1]. You don't have to buy license key right away - take advantage of our [2]14-days free trial[/2] plan" => $this->l('In order to use this module you need valid [1]license key[/1]. You don\'t have to buy license key right away - take advantage of our [2]14-days free trial[/2] plan'),
            "Invalid number" => $this->l('Invalid number'),
            "Label" => $this->l('Label'),
            "Layout" => $this->l('Layout'),
            "Left" => $this->l('Left'),
            "License information" => $this->l('License information'),
            "License key" => $this->l('License key'),
            "License" => $this->l('License'),
            "Marketing offers" => $this->l('Marketing offers'),
            "Multi-line text" => $this->l('Multi-line text'),
            "New account creation field" => $this->l('New account creation field'),
            "New entry field" => $this->l('New entry field'),
            "New module version is available" => $this->l('New module version is available'),
            "New release notification" => $this->l('New release notification'),
            "New version [1]%s[/1] is available. Last check %s" => $this->l('New version [1]%s[/1] is available. Last check %s'),
            "No information available. Please click on [1]Check for updates[/1] button to check for new version of this module" => $this->l('No information available. Please click on [1]Check for updates[/1] button to check for new version of this module'),
            "Number" => $this->l('Number'),
            "Password" => $this->l('Password'),
            "Placeholder" => $this->l('Placeholder'),
            "Please enter domain name" => $this->l('Please enter domain name'),
            "Please enter license key" => $this->l('Please enter license key'),
            "Please enter your contact email address" => $this->l('Please enter your contact email address'),
            "Please read carefully and agree to our [1]terms and conditions[/1] before you start using this module." => $this->l('Please read carefully and agree to our [1]terms and conditions[/1] before you start using this module.'),
            "Product image" => $this->l('Product image'),
            "Purchase license" => $this->l('Purchase license'),
            "Required" => $this->l('Required'),
            "Right" => $this->l('Right'),
            "Sandbox mode allows you to [1]safely evaluate[/1] functionality of this module. Module will be active only for visitors with whitelisted IP addresses" => $this->l('Sandbox mode allows you to [1]safely evaluate[/1] functionality of this module. Module will be active only for visitors with whitelisted IP addresses'),
            "Sandbox mode" => $this->l('Sandbox mode'),
            "Save changes" => $this->l('Save changes'),
            "Save" => $this->l('Save'),
            "Select field" => $this->l('Select field'),
            "Separate shipping and billing block" => $this->l('Separate shipping and billing block'),
            "Settings" => $this->l('Settings'),
            "Show logo for carriers" => $this->l('Show logo for carriers'),
            "Show logo for payment methods" => $this->l('Show logo for payment methods'),
            "Start using module" => $this->l('Start using module'),
            "Start your free trial" => $this->l('Start your free trial'),
            "State selector" => $this->l('State selector'),
            "Support" => $this->l('Support'),
            "Telephone" => $this->l('Telephone'),
            "Text" => $this->l('Text'),
            "Thank you for installing [1]One Page Checkout[/1] module. We are very happy to have you aboard." => $this->l('Thank you for installing [1]One Page Checkout[/1] module. We are very happy to have you aboard.'),
            "Top" => $this->l('Top'),
            "Tutorials and suggestions" => $this->l('Tutorials and suggestions'),
            "Unified shipping and billing block" => $this->l('Unified shipping and billing block'),
            "Update module" => $this->l('Update module'),
            "We need your permission to contact you in [1]emergency[/1] situations, for example if we discover a serious [2]security[/2] bug" => $this->l('We need your permission to contact you in [1]emergency[/1] situations, for example if we discover a serious [2]security[/2] bug'),
            "We promise that we will [1]not disclose[/1] your email address to anyone or use it to [2]spam[/2] you. We will not send you automated [3]marketing[/3] emails unless you [4]opt-in[/4] for it.[5][/5]You can read our [6]privacy policy[6] here." => $this->l('We promise that we will [1]not disclose[/1] your email address to anyone or use it to [2]spam[/2] you. We will not send you automated [3]marketing[/3] emails unless you [4]opt-in[/4] for it.[5][/5]You can read our [6]privacy policy[6] here.'),
            "What emails can we send you?" => $this->l('What emails can we send you?'),
            "Whitelisted IP addresses" => $this->l('Whitelisted IP addresses'),
            "You can contact me" => $this->l('You can contact me'),
            "You can purchase license for this module on [1]datakick website[/1]" => $this->l('You can purchase license for this module on [1]datakick website[/1]'),
            "You have latest version [1]%s[/1] of this module. Last check %s" => $this->l('You have latest version [1]%s[/1] of this module. Last check %s'),
            "You need to purchase license key in order to use this module" => $this->l('You need to purchase license key in order to use this module'),
            "Your license is valid for domain [1]%s[/1] and all its subdomains" => $this->l('Your license is valid for domain [1]%s[/1] and all its subdomains'),
            "Your license is valid for domain [1]%s[/1] and all its subdomains, and will expire [2]%s[/2]" => $this->l('Your license is valid for domain [1]%s[/1] and all its subdomains, and will expire [2]%s[/2]'),
            "custom field" => $this->l('custom field'),
            "learn how to utilize this module to its full potential" => $this->l('learn how to utilize this module to its full potential'),
            "required field" => $this->l('required field'),
            "we can send you discount offers or deals" => $this->l('we can send you discount offers or deals'),
            "we will let you know when new version is available" => $this->l('we will let you know when new version is available')
        ));
    }

    /**
     * @param string $str
     *
     * @return string
     *
     * @noinspection PhpUnused
     * @noinspection PhpUnusedPrivateMethodInspection
     */
    private function l($str)
    {
        return html_entity_decode($this->module->l($str, 'app-translation'));
    }

    /**
     * @param array $array
     *
     * @return array
     */
    private function changed($array)
    {
        $ret = [];
        foreach ($array as $key => $value) {
            if ($value != $key) {
                $ret[$key] = $value;
            }
        }
        return $ret;
    }
}
