<?php
/**
 * Copyright (C) 2017-2019 Petr Hucik <petr@getdatakick.com>
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@getdatakick.com so we can send you a copy immediately.
 *
 * @author    Petr Hucik <petr@getdatakick.com>
 * @copyright 2017-2019 Petr Hucik
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 */

namespace Chex;

use ObjectModel;

interface EntryFieldsIntegration
{
    /**
     * @return string
     */
    function getId();

    /**
     * This method should return *all* entry fields defined by the module. If the entry field should not be used in
     * current context, it should have 'hidden' => true flag
     *
     * @return array[]
     */
    function getEntryFields();

    /**
     * @param string $id
     * @param mixed $value
     * @param ObjectModel $object
     * @return mixed
     */
    function processEntryField($id, $value, $object);

    /**
     * @param string $fieldId
     * @param string $search
     * @return mixed
     */
    function getSelectOptions($fieldId, $search);

}

