<?php
/**
 * Copyright (C) 2017-2019 Petr Hucik <petr@getdatakick.com>
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@getdatakick.com so we can send you a copy immediately.
 *
 * @author    Petr Hucik <petr@getdatakick.com>
 * @copyright 2017-2019 Petr Hucik
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 */

namespace Chex;

use Cart;

interface ShippingIntegration
{
    /**
     * @param array $carrier
     * @return array[]
     */
    function getCarrierEntryFields($carrier);

    /**
     * @param array $carrier
     *
     * @return boolean
     */
   function handlesCarrier($carrier);

    /**
     * @param Cart $cart
     * @param array $carrier
     * @param array $data
     * @return mixed
     */
   function processData(Cart $cart, $carrier, $data);

    /**
     * @param string $field
     * @param string $search
     * @param array $carrier
     * @return mixed
     */
   function getSelectOptions($field, $search, $carrier);
}

