CREATE TABLE IF NOT EXISTS `PREFIX_chex_field_preference` (
  `module`          VARCHAR(120) NOT NULL,
  `field`           VARCHAR(120) NOT NULL,
  `active`          TINYINT(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`module`, `field`)
) ENGINE=ENGINE_TYPE DEFAULT CHARSET=CHARSET_TYPE;

INSERT INTO `PREFIX_chex_field_preference`(`module`, `field`, `active`) VALUES('chex', 'address.dni', 0);

CREATE TABLE IF NOT EXISTS `PREFIX_chex_custom_field` (
  `id`            VARCHAR(120) NOT NULL,
  `type`          VARCHAR(40) NOT NULL,
  `label`         VARCHAR(255) NOT NULL,
  `placeholder`   VARCHAR(255) NULL,
  `required_message`  VARCHAR(255) NULL,
  `required`      TINYINT(1) NOT NULL,
  `default_value` VARCHAR(255) NULL,
  `validate`      VARCHAR(80) NULL,
  `icon`          VARCHAR(80) NULL,
  PRIMARY KEY (`id`)
) ENGINE=ENGINE_TYPE DEFAULT CHARSET=CHARSET_TYPE;

CREATE TABLE IF NOT EXISTS `PREFIX_chex_field_value_bool` (
  `id_cart`       INT(11) NOT NULL,
  `field`         VARCHAR(120) NOT NULL,
  `id_entity`     INT(11) NOT NULL,
  `value`         TINYINT(1) NOT NULL DEFAULT 0,
  `section`       VARCHAR(80) NOT NULL,
  PRIMARY KEY (`id_cart`, `field`)
) ENGINE=ENGINE_TYPE DEFAULT CHARSET=CHARSET_TYPE;

CREATE TABLE IF NOT EXISTS `PREFIX_chex_field_value_int` (
  `id_cart`       INT(11) NOT NULL,
  `field`         VARCHAR(120) NOT NULL,
  `id_entity`     INT(11) NOT NULL,
  `value`         INT(11) NULL,
  `section`       VARCHAR(80) NOT NULL,
  PRIMARY KEY (`id_cart`, `field`, `id_entity`)
) ENGINE=ENGINE_TYPE DEFAULT CHARSET=CHARSET_TYPE;

CREATE TABLE IF NOT EXISTS `PREFIX_chex_field_value_text` (
  `id_cart`       INT(11) NOT NULL,
  `field`         VARCHAR(120) NOT NULL,
  `id_entity`     INT(11) NOT NULL,
  `value`         VARCHAR(255) NULL,
  `section`       VARCHAR(80) NOT NULL,
  PRIMARY KEY (`id_cart`, `field`, `id_entity`)
) ENGINE=ENGINE_TYPE DEFAULT CHARSET=CHARSET_TYPE;

CREATE TABLE IF NOT EXISTS `PREFIX_chex_field_value_longtext` (
  `id_cart`       INT(11) NOT NULL,
  `field`         VARCHAR(120) NOT NULL,
  `id_entity`     INT(11) NOT NULL,
  `value`         TEXT,
  `section`       VARCHAR(80) NOT NULL,
  PRIMARY KEY (`id_cart`, `field`, `id_entity`)
) ENGINE=ENGINE_TYPE DEFAULT CHARSET=CHARSET_TYPE;
